#NoTrayIcon

#RequireAdmin

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Organizer\Organizer.ico
#AutoIt3Wrapper_Outfile=Organizer.exe
#AutoIt3Wrapper_Res_Comment=Le petit module pour grer ses fentres Dofus !
#AutoIt3Wrapper_Res_Description=Le petit module pour grer ses fentres Dofus !
#AutoIt3Wrapper_Res_Fileversion=1.2.0.1
#AutoIt3Wrapper_Res_LegalCopyright=ZDS
#AutoIt3Wrapper_Res_Language=1036
#AutoIt3Wrapper_Res_Field=PROJECT|nAiO
#AutoIt3Wrapper_Res_Field=name|Organizer
#AutoIt3Wrapper_Res_Field=type|Module
#AutoIt3Wrapper_Res_Field=auto|True
#AutoIt3Wrapper_Res_Field=version|1.2a
#AutoIt3Wrapper_Res_Field=description|Gestionnaire de fentres
#AutoIt3Wrapper_Res_Field=url|http://www.naio.fr
#AutoIt3Wrapper_Run_Before="7z.exe a -tzip "%scriptdir%\Sources.zip" "%scriptdir%\Organizer.au3""
#AutoIt3Wrapper_Run_Before="7z.exe a -tzip "%scriptdir%\Sources.zip" "%scriptdir%\Organizer""
#AutoIt3Wrapper_Run_After="del "%scriptdir%\Sources.zip""
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; ### Region Librairies AutoIt

#Include <Array.au3>
#include <GuiButton.au3>
#Include <GDIPlus.au3>
#Include <WinAPI.au3>

; ### Region Librairies du nAiO

#Include ".\Organizer\Include\Communication.au3"
#Include ".\Organizer\Include\Compilation.au3"
#Include ".\Organizer\Include\Divers.au3"
#Include ".\Organizer\Include\Evolution.au3"
#Include ".\Organizer\Include\Menus.au3"
#Include ".\Organizer\Include\Modelisation.au3"
#Include ".\Organizer\Include\Semaphores.au3"

; ### Region Excution du programme

Exit onLaunch()

; ### Region Point d'entre du programme

Func onLaunch()
	If onSources() Then
		; Initialisation
		Local $WorkingDir = @WorkingDir
		FileChangeDir(@ScriptDir)
		; Extraction
		FileInstall(".\Sources.zip", ".\Organizer-Sources.zip", 1)
		; Finalisation
		FileChangeDir($WorkingDir)
	ElseIf onHelp() Then
		MsgBox(0, "Aide du fichier """&@ScriptName&"""", "Liste des commandes utilisables :"     _
			& @CRLF & "-"&"  "&"/?, /h ou /help :"  & @TAB & "Afficher ce message d'aide"        _
			& @CRLF & "-"&"  "&"/src ou /sources :" & @TAB & "Extraire les sources du programme" _
			& @CRLF & "-"&"  "&"/debug :"           & @TAB & "Lancer le programme en mode dbug" _
		)
	ElseIf onAuto() Then
		onStart()
		OnAutoItExitRegister("onExit")
		If singleton() Then
			ORGANIZER_display(True)
		EndIf
	Else
		onStart()
		OnAutoItExitRegister("onExit")
		If singleton() Then
			ORGANIZER_display(False)
		EndIf
	EndIf
	Return 0
EndFunc

Func onSources()
	For $i = 1 To $CmdLine[0]
		If StringRegExp($CmdLine[$i], "^(?i)(-|/)(src|source|sources)$") Then Return True
	Next
	Return False
EndFunc

Func onHelp()
	For $i = 1 To $CmdLine[0]
		If StringRegExp($CmdLine[$i], "^(?i)(-|/)(\?|help|h)$") Then Return True
	Next
	Return False
EndFunc

Func onDebug()
	If IsDeclared("onDebug") Then
		Global $onDebug
		Return $onDebug
	EndIf
	Global $onDebug = False
	For $i = 1 To $CmdLine[0]
		If StringRegExp($CmdLine[$i], "^(?i)(-|/)(debug)$") Then $onDebug = True
	Next
	If $onDebug Then FileClose(FileOpen(ORGANIZER_debug_file(), 10))
	Return $onDebug
EndFunc

Func onAuto()
	For $i = 1 To $CmdLine[0]
		If StringRegExp($CmdLine[$i], "^(?i)(-|/)(auto)$") Then Return True
	Next
	Return False
EndFunc

Func onFirstLaunch()
	Local $resultat = False
	If Not FileExists(ORGANIZER_config_file()) Then
		$resultat = True
	EndIf
	Return $resultat
EndFunc

Func onStart()
	Global Const $USER32_DLL = DllOpen("user32.dll"), $MAILSLOT_COMMAND = MailSlot_Create("Command-"&@AutoItPID)
	If Not FileExists(ORGANIZER_folder())      Then DirCreate(ORGANIZER_folder())
	If Not FileExists(ORGANIZER_config_file()) Then FileClose(FileOpen(ORGANIZER_config_file(), 10))
	compilation_extract_files()
	upgrade_to_current_version()
EndFunc

Func onExit()
	If IsDeclared("USER32_DLL") Then DllClose($USER32_DLL)
	If IsDeclared("MAILSLOT_COMMAND") Then MailSlot_Close($MAILSLOT_COMMAND)
EndFunc

Func ORGANIZER_display($onAuto=False)
	Local $resultat = ($onAuto?"ACTIVATE_AUTO":"CONFIG")
	Do
		Switch $resultat
			Case "QUIT"
				; Rien
			Case "CONFIG"
				$resultat = ORGANIZER_displayGUI()
			Case "ACTIVATE_AUTO"
				$resultat = ORGANIZER_displayTray(True)
			Case "ACTIVATE"
				$resultat = ORGANIZER_displayTray(False)
			Case Else
				$resultat = "QUIT"
		EndSwitch
	Until $resultat = "QUIT"
EndFunc

Func ORGANIZER_displayTray($flag)
	; Initialisation
	Global $ORGANIZER_fenetres = ORGANIZER_getWinList()
	Global $ORGANIZER_commandes[3] = [2 _
		, IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "Previous", "") _
		, IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "Next",     "") _
	]
	; Activation des raccourcis
	Local $nShortcuts = startShortcuts()
	; Cration des lments graphiques
	Global $TRAY = _TrayIconCreate(field("name")&" v"&field("version"), @ScriptFullPath), $TRAY_context = _TrayCreateContextMenu($TRAY)
	Global $TRAY_about      = _GUICtrlCreateODMenuItem("A propos...",      $TRAY_context)
	Global $TRAY_separator1 = _GUICtrlCreateODMenuItem("",                 $TRAY_context)
	Global $TRAY_refresh    = _GUICtrlCreateODMenuItem("Rafrachir/trier", $TRAY_context)
	Global $TRAY_config     = _GUICtrlCreateODMenuItem("Configurer",       $TRAY_context)
	Global $TRAY_separator2 = _GUICtrlCreateODMenuItem("",                 $TRAY_context)
	Global $TRAY_quit       = _GUICtrlCreateODMenuItem("Quitter",          $TRAY_context)
	_GUICtrlODMenuItemSetIcon($TRAY_about,   @ScriptFullPath)
	_GUICtrlODMenuItemSetIcon($TRAY_refresh, ORGANIZER_folder()&"\Images\Actualiser.ico")
	_GUICtrlODMenuItemSetIcon($TRAY_config,  ORGANIZER_folder()&"\Images\Configurer.ico")
	_GUICtrlODMenuItemSetIcon($TRAY_quit,    ORGANIZER_folder()&"\Images\Sortir.ico")
	; Affichage
	_TrayIconSetClick($TRAY, 2+16) ; Releasing primary = 2 ; Releasing secondary = 16
	_TrayIconSetState($TRAY, 1)
	If Not $flag Then ORGANIZER_displayTray_traytip(False, $nShortcuts, $ORGANIZER_fenetres)
	Local $quit = False, $config = False
	Do
;~ 		Sleep(20)
		Local $msg = ORGANIZER_msg(0)
		If $msg = 0 Then
			$msg = GUIGetMsg()
		EndIf
		If $msg = 0 Then
			Local $message = MailSlot_Read($MAILSLOT_COMMAND)
			Switch $message
				Case "@quit"
					$quit = True
			EndSwitch
		EndIf
		Switch $msg
			Case $TRAY_about
				ORGANIZER_displayTray_traytip(True, $nShortcuts, $ORGANIZER_fenetres)
			Case $TRAY_refresh
				stopShortcuts()
				$ORGANIZER_fenetres = ORGANIZER_getWinList()
				For $i = 1 To $ORGANIZER_fenetres[0]
					_TrayTip($TRAY, field("name")&" v"&field("version")&" - "&"Tri", "Veuillez patienter pendant le tri ("&$i&" sur "&$ORGANIZER_fenetres[0]&") ...", 10, 2)
					Local $handle = fenetre_handle($ORGANIZER_fenetres[$i])
					WinSetState($handle, "", @SW_HIDE)
					WinSetState($handle, "", @SW_SHOW)
				Next
				_TrayTip($TRAY, "", "")
				$nShortcuts = startShortcuts()
				ORGANIZER_displayTray_traytip(False, $nShortcuts, $ORGANIZER_fenetres)
			Case $TRAY_config
				$config = True
			Case $TRAY_quit
				$quit = True
		EndSwitch
	Until $quit Or $config
	; Destruction des lments graphiques
	_TrayDeleteItem($TRAY_about)
	_TrayDeleteItem($TRAY_separator1)
	_TrayDeleteItem($TRAY_refresh)
	_TrayDeleteItem($TRAY_config)
	_TrayDeleteItem($TRAY_separator2)
	_TrayDeleteItem($TRAY_quit)
	_TrayDeleteItem($TRAY_context)
	_TrayIconDelete($TRAY)
	; Dsactivation des raccourcis
	stopShortcuts()
	Return ($quit?"QUIT":"CONFIG")
EndFunc

Func ORGANIZER_displayTray_traytip($about, $nShortcuts, $windows, $timeout=5)
	Local $text1 = ($nShortcuts+$windows[0])&" lment"&($nShortcuts+$windows[0]>1?"s":"")&" dtect"&($nShortcuts+$windows[0]>1?"s":"")
	Local $text2 = @CRLF & @CRLF & "Cliquez sur l'icone pour modifier ou rafrachir"
	If $nShortcuts+$windows[0] = 0 Then
		$text1 = "Aucun lment dtect (ni fentre, ni raccourci)"
	Else
		$text1 = $text1 & " (" & ($windows[0]>0?$windows[0]:"Aucune") & " fentre" & ($windows[0]>1?"s":"") & ", " & ($nShortcuts>0?$nShortcuts:"aucun") & " raccourci" & ($nShortcuts>1?"s":"") & ")"
		If $windows[0] > 0 Then
			$text1 = $text1 & " :"
			For $i = 1 To $windows[0]
				$text1 = $text1 & ($i<>1 ? ", " : @CRLF) & """"&fenetre_alias($windows[$i])&""""
			Next
		EndIf
	EndIf
	Local $size = StringLen($text1)+StringLen($text2), $text = $text1&$text2, $etc = " ..."
	If $size > 255 Then $text = StringLeft($text1, 255-StringLen($etc)-StringLen($text2))&$etc&$text2
	_TrayTip($TRAY, field("name")&" v"&field("version")&($about?" - A propos...":""), $text, $timeout, 4)
EndFunc

Func startShortcuts()
	Return modifyShortcuts(True)
EndFunc

Func stopShortcuts()
	Return modifyShortcuts(False)
EndFunc

Func modifyShortcuts($flag)
	Local $resultat = 0
	Local $shortcut = $ORGANIZER_commandes[1], $test = shortcut_toString($shortcut)
	If Not @error Then
		If $flag Then
			HotKeySet($shortcut, "ORGANIZER_detectShortcut_previous")
		Else
			HotKeySet($shortcut)
		EndIf
		$resultat = $resultat+1
	EndIf
	Local $shortcut = $ORGANIZER_commandes[2], $test = shortcut_toString($shortcut)
	If Not @error Then
		If $flag Then
			HotKeySet($shortcut, "ORGANIZER_detectShortcut_next")
		Else
			HotKeySet($shortcut)
		EndIf
		$resultat = $resultat+1
	EndIf
	For $i = 1 To $ORGANIZER_fenetres[0]
		Local $shortcut = fenetre_shortcut($ORGANIZER_fenetres[$i]), $test = shortcut_toString($shortcut)
		If Not @error Then
			If $flag Then
				HotKeySet($shortcut, "ORGANIZER_detectShortcut")
			Else
				HotKeySet($shortcut)
			EndIf
			$resultat = $resultat+1
		EndIf
	Next
	Return $resultat
EndFunc

Func ORGANIZER_displayGUI()
	; Initialisation
	Global $ORGANIZER_fenetres[1] = [0]
	Global $ORGANIZER_commandes[3] = [2 _
		, IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "Previous", "") _
		, IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "Next",     "") _
	]
	; Interface
	Global $ORGANIZER_GUI_size[2] = [340, 200]
	Global $ORGANIZER_GUI_position[2] = [ _
		Number(IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "PositionX", (@DesktopWidth  - $ORGANIZER_GUI_size[0])/2)), _
		Number(IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "PositionY", (@DesktopHeight - $ORGANIZER_GUI_size[1])/2))  _
	]
	Global $ORGANIZER_GUI = GUICreate(field("name")&" v"&field("version"), $ORGANIZER_GUI_size[0], $ORGANIZER_GUI_size[1], $ORGANIZER_GUI_position[0], $ORGANIZER_GUI_position[1], 0x80800000, 0x00000010) ; $WS_POPUP = 0x80000000 ; $WS_BORDER = 0x00800000 ; $WS_EX_ACCEPTFILES = 0x00000010
	GUISetIcon(@ScriptFullPath, Default, $ORGANIZER_GUI)
	; Elments principaux
	Global $ORGANIZER_reduire = GUICtrlCreateButton("", 10, 10, 25, 25)
	Global $ORGANIZER_titre = GUICtrlCreateLabel(field("name")&" v"&field("version"), 45, 10, $ORGANIZER_GUI_size[0]-90, 25)
	Global $ORGANIZER_quitter = GUICtrlCreateButton("", $ORGANIZER_GUI_size[0]-35, 10, 25, 25)
	; Habillage
	GUICtrlSetState($ORGANIZER_reduire, 0x80) ; $GUI_DISABLE = 0x80
	GUICtrlSetStyle($ORGANIZER_titre,   0x0101) ; $SS_NOTIFY = 0x0100 ; $SS_CENTER = 0x0001
	GUICtrlSetStyle($ORGANIZER_quitter, 0x40) ; $BS_ICON = 0x40
	GUICtrlSetImage($ORGANIZER_quitter, ORGANIZER_folder()&"\Images\Quitter.ico")
	GUICtrlSetBkColor($ORGANIZER_titre, -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetFont($ORGANIZER_titre,    15, 800)
	; Elments spcifiques
	Global $elements[$ORGANIZER_fenetres[0]+1] = [$ORGANIZER_fenetres[0]]
	Global $ORGANIZER_icons = $elements, $ORGANIZER_labels = $elements, $ORGANIZER_inputs = $elements, $ORGANIZER_buttons = $elements, $ORGANIZER_checkboxes = $elements
	Global $ORGANIZER_nothing = GUICtrlCreateLabel("Aucune fentre Dofus visible, cliquez sur [Rafrachir]", 10, 48, $ORGANIZER_GUI_size[0]-20, 20, 0x0001) ; $SS_CENTER = 0x0001
	Global $ORGANIZER_icons_header      = GUICtrlCreateLabel("",            10-5, 50,  20+10, 18, 0x0001) ; $SS_CENTER = 0x0001
	Global $ORGANIZER_labels_header     = GUICtrlCreateLabel("Personnage",  40-5, 50, 105+10, 18, 0x0001) ; $SS_CENTER = 0x0001
	Global $ORGANIZER_inputs_header     = GUICtrlCreateLabel("Initiative", 155-5, 50,  55+10, 18, 0x0001) ; $SS_CENTER = 0x0001
	Global $ORGANIZER_buttons_header    = GUICtrlCreateLabel("Raccourci",  220-5, 50,  80+10, 18, 0x0001) ; $SS_CENTER = 0x0001
	Global $ORGANIZER_checkboxes_header = GUICtrlCreateLabel("",           310-5, 50,  20+10, 18, 0x0001) ; $SS_CENTER = 0x0001
	; Habillage
	GUICtrlSetFont($ORGANIZER_icons_header,      9, Default, 0x04) ; $GUI_FONTUNDER = 0x04
	GUICtrlSetFont($ORGANIZER_labels_header,     9, Default, 0x04) ; $GUI_FONTUNDER = 0x04
	GUICtrlSetFont($ORGANIZER_inputs_header,     9, Default, 0x04) ; $GUI_FONTUNDER = 0x04
	GUICtrlSetFont($ORGANIZER_buttons_header,    9, Default, 0x04) ; $GUI_FONTUNDER = 0x04
	GUICtrlSetFont($ORGANIZER_checkboxes_header, 9, Default, 0x04) ; $GUI_FONTUNDER = 0x04
	GUICtrlSetBkColor($ORGANIZER_icons_header,              -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetBkColor($ORGANIZER_labels_header,             -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetBkColor($ORGANIZER_inputs_header,             -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetBkColor($ORGANIZER_buttons_header,            -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetBkColor($ORGANIZER_checkboxes_header,         -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
	GUICtrlSetState($ORGANIZER_nothing,                   0x10) ; $GUI_SHOW = 0x10
	GUICtrlSetState($ORGANIZER_icons_header,              0x20) ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_labels_header,             0x20) ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_inputs_header,             0x20) ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_buttons_header,            0x20) ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_checkboxes_header,         0x20) ; $GUI_HIDE = 0x20
	; Elments communs
	Global $ORGANIZER_buttonPrevious = GUICtrlCreateButton("",                         10, $ORGANIZER_GUI_size[1]-125, $ORGANIZER_GUI_size[0]/2-15, 25)
	Global $ORGANIZER_buttonNext     = GUICtrlCreateButton("", $ORGANIZER_GUI_size[0]/2+5, $ORGANIZER_GUI_size[1]-125, $ORGANIZER_GUI_size[0]/2-15, 25)
	Global $ORGANIZER_separator      = GUICtrlCreateLabel("",                          10,  $ORGANIZER_GUI_size[1]-90,   $ORGANIZER_GUI_size[0]-20,  1)
	Global $ORGANIZER_buttonRefresh  = GUICtrlCreateButton(" En cours de traitement",  10,  $ORGANIZER_GUI_size[1]-80,   $ORGANIZER_GUI_size[0]-20, 25)
	Global $ORGANIZER_editInfos      = GUICtrlCreateEdit("",                           10,  $ORGANIZER_GUI_size[1]-45,   $ORGANIZER_GUI_size[0]-20, 35)
	GUICtrlSetStyle($ORGANIZER_editInfos,   0x0801) ; $ES_READONLY = 0x0800 ; $ES_CENTER = 0x0001
	GUICtrlSetBkColor($ORGANIZER_editInfos, 0xFFFFFF)
	GUICtrlSetFont($ORGANIZER_editInfos,    7, 400, 2)
	GUICtrlSetData($ORGANIZER_editInfos,    "Les raccourcis ne sont pas utilisables pendant la configuration." & @CRLF & "Pour les activer, cliquez sur la croix en haut  droite.")
	; Habillage
	GUICtrlSetData($ORGANIZER_buttonPrevious,   " "&shortcut_toString($ORGANIZER_commandes[1], 2))
	GUICtrlSetData($ORGANIZER_buttonNext,       " "&shortcut_toString($ORGANIZER_commandes[2], 2))
	_GUICtrlSetImage($ORGANIZER_buttonPrevious, ORGANIZER_folder()&"\Images\Gauche.ico")
	_GUICtrlSetImage($ORGANIZER_buttonNext,     ORGANIZER_folder()&"\Images\Droite.ico")
	_GUICtrlSetImage($ORGANIZER_buttonRefresh,  ORGANIZER_folder()&"\Images\Actualiser.ico")
	GUICtrlSetBkColor($ORGANIZER_separator,     0x000000)
	; Positionnement
	GUICtrlSetResizing($ORGANIZER_reduire,           0x0102 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_titre,             0x0006 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_quitter,           0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_nothing,           0x0006 + 0x0060) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKBOTTOM = 0x0040
	GUICtrlSetResizing($ORGANIZER_icons_header,      0x0102 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_labels_header,     0x0006 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_inputs_header,     0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_buttons_header,    0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_checkboxes_header, 0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH   = 0x0100 ; $GUI_DOCKTOP    = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_buttonPrevious,    0x000A + 0x0240) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKHCENTER = 0x0008 ; $GUI_DOCKBOTTOM = 0x0040 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_buttonNext,        0x000C + 0x0240) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKHCENTER = 0x0008 ; $GUI_DOCKBOTTOM = 0x0040 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_separator,         0x0006 + 0x0240) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKBOTTOM = 0x0040 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_buttonRefresh,     0x0006 + 0x0240) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKBOTTOM = 0x0040 ; $GUI_DOCKHEIGHT = 0x0200
	GUICtrlSetResizing($ORGANIZER_editInfos,         0x0006 + 0x0240) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT   = 0x0004 ; $GUI_DOCKBOTTOM = 0x0040 ; $GUI_DOCKHEIGHT = 0x0200
	; Affichage
	GUISetState(@SW_SHOW, $ORGANIZER_GUI)
	; Premire mise  jour
	GUISetState(@SW_DISABLE, $ORGANIZER_GUI)
	ORGANIZER_refresh(False)
	GUICtrlSetData($ORGANIZER_buttonRefresh, " Rafrachir la liste et trier les fentres")
	GUISetState(@SW_ENABLE, $ORGANIZER_GUI)
	WinActivate($ORGANIZER_GUI)
	; Traitement
	Local $quit = False, $activate = False, $focus = 0
	registerMsg_ORGANIZER()
	Do
		; Focus
		If $focus <> WinGetHandle("[ACTIVE]") Then
			$focus = WinGetHandle("[ACTIVE]")
			ToolTip("")
		EndIf
;~ 		Sleep(20)
		Local $msg = ORGANIZER_msg(0)
		If $msg = 0 Then
			$msg = GUIGetMsg()
		EndIf
		If $msg = 0 Then
			Local $message = MailSlot_Read($MAILSLOT_COMMAND)
			Switch $message
				Case "@quit"
					$quit = True
			EndSwitch
		EndIf
		Switch $msg
			Case -3, $ORGANIZER_quitter ; $GUI_EVENT_CLOSE = -3
				GUISwitch($ORGANIZER_GUI)
				Local $dummy = GUICtrlCreateDummy(), $context = GUICtrlCreateContextMenu($dummy)
				Local $item_activate = _GUICtrlCreateODMenuItem("Activer les raccourcis", $context)
				Local $item_quit     = _GUICtrlCreateODMenuItem("Quitter compltement",   $context)
				_GUICtrlODMenuItemSetIcon($item_activate, ORGANIZER_folder()&"\Images\Activer.ico")
				_GUICtrlODMenuItemSetIcon($item_quit,     ORGANIZER_folder()&"\Images\Sortir.ico")
				; Affichage
				sousmenu($ORGANIZER_GUI, $ORGANIZER_quitter, $context)
				Local $timer = TimerInit()
				Do
;~ 					Sleep(20)
					Local $submsg = GUIGetMsg()
				Until $submsg > 0 Or TimerDiff($timer) > 250
				; Traitement
				If $submsg = 0 Then
					; Rien
				ElseIf $submsg = $item_activate Then
					$activate = True
				ElseIf $submsg = $item_quit Then
					$quit = True
				EndIf
				; Destruction
				_GUICtrlODMenuItemDelete($item_activate)
				_GUICtrlODMenuItemDelete($item_quit)
				GUICtrlDelete($context)
				GUICtrlDelete($dummy)
			Case -10 ; $GUI_EVENT_SECONDARYDOWN = -9 ; $GUI_EVENT_SECONDARYUP = -10
				Local $info = GUIGetCursorInfo($ORGANIZER_GUI)
				If Not @error And _GUICtrlGetState($info[4], 0x40) Then ; $GUI_ENABLE = 0x40
					Switch $info[4]
						Case $ORGANIZER_buttonPrevious, $ORGANIZER_buttonNext
							Local $index = ($info[4] = $ORGANIZER_buttonPrevious ? 1 : 2)
							GUISwitch($ORGANIZER_GUI)
							Local $dummy = GUICtrlCreateDummy(), $context = GUICtrlCreateContextMenu($dummy)
							Local $item_remove = _GUICtrlCreateODMenuItem("Retirer le raccourci", $context)
							_GUICtrlODMenuItemSetIcon($item_remove, ORGANIZER_folder()&"\Images\Sortir.ico")
							; Affichage
							sousmenu($ORGANIZER_GUI, $info[4], $context)
							Local $timer = TimerInit()
							Do
;~ 								Sleep(20)
								Local $submsg = GUIGetMsg()
							Until $submsg > 0 Or TimerDiff($timer) > 250
							; Traitement
							If $submsg = 0 Then
								; Rien
							ElseIf $submsg = $item_remove Then
								Local $shortcut = ""
								$ORGANIZER_commandes[$index] = $shortcut
								GUICtrlSetData($info[4], " "&shortcut_toString($shortcut, 2))
							EndIf
							; Destruction
							_GUICtrlODMenuItemDelete($item_remove)
							GUICtrlDelete($context)
							GUICtrlDelete($dummy)
						Case Else
							For $i = 1 To $ORGANIZER_fenetres[0]
								If $info[4] = $ORGANIZER_buttons[$i] Then
									GUISwitch($ORGANIZER_GUI)
									Local $dummy = GUICtrlCreateDummy(), $context = GUICtrlCreateContextMenu($dummy)
									Local $item_remove = _GUICtrlCreateODMenuItem("Retirer le raccourci", $context)
									_GUICtrlODMenuItemSetIcon($item_remove, ORGANIZER_folder()&"\Images\Sortir.ico")
									; Affichage
									sousmenu($ORGANIZER_GUI, $info[4], $context)
									Local $timer = TimerInit()
									Do
;~ 										Sleep(20)
										Local $submsg = GUIGetMsg()
									Until $submsg > 0 Or TimerDiff($timer) > 250
									; Traitement
									If $submsg = 0 Then
										; Rien
									ElseIf $submsg = $item_remove Then
										Local $shortcut = ""
										fenetre_shortcut($ORGANIZER_fenetres[$i], $shortcut)
										GUICtrlSetData($info[4], shortcut_toString($shortcut, 1))
									EndIf
									; Destruction
									_GUICtrlODMenuItemDelete($item_remove)
									GUICtrlDelete($context)
									GUICtrlDelete($dummy)
								EndIf
							Next
					EndSwitch
				EndIf
			Case $ORGANIZER_titre
				ToolTip("")
				_SendMessage($ORGANIZER_GUI, 0x0112, 0xF012, 0) ; $WM_SYSCOMMAND = 0x0112
				WinActivate($ORGANIZER_GUI)
				Local $position = WinGetPos($ORGANIZER_GUI)
				If Not @error Then
					$ORGANIZER_GUI_position[0] = $position[0]
					$ORGANIZER_GUI_position[1] = $position[1]
				EndIf
			Case $ORGANIZER_buttonPrevious, $ORGANIZER_buttonNext
				Local $index = ($msg = $ORGANIZER_buttonPrevious ? 1 : 2)
				unregisterMsg_ORGANIZER()
				Local $shortcut = ORGANIZER_catchShortcut($ORGANIZER_commandes[$index])
				If Not @error Then
					$ORGANIZER_commandes[$index] = $shortcut
					GUICtrlSetData($msg, " "&shortcut_toString($shortcut, 2))
				EndIf
				registerMsg_ORGANIZER()
			Case $ORGANIZER_buttonRefresh
				unregisterMsg_ORGANIZER()
				Local $text = GUICtrlRead($ORGANIZER_buttonRefresh)
				GUISetState(@SW_DISABLE, $ORGANIZER_GUI)
				GUICtrlSetData($ORGANIZER_buttonRefresh, " En cours de traitement")
				ORGANIZER_refresh()
				GUICtrlSetData($ORGANIZER_buttonRefresh, $text)
				GUISetState(@SW_ENABLE, $ORGANIZER_GUI)
				WinActivate($ORGANIZER_GUI)
				registerMsg_ORGANIZER()
			Case Else
				; Boutons des fentres
				For $i = 1 To $ORGANIZER_fenetres[0]
					Switch $msg
						Case $ORGANIZER_icons[$i]
							unregisterMsg_ORGANIZER()
							Local $avatars = NAIO_avatars()
							If $avatars[0] > 0 Then
								; Implmentation
								Local $avatars_menuitems = $avatars, $avatars_menus[1] = [0], $avatars_actualMenu[2] = [0,""]
								; Cration des menus
								Local $dummy = GUICtrlCreateDummy(), $context = GUICtrlCreateContextMenu($dummy), $separator = 0, $erase_item = 0
								; Traitement des comptes
								For $j = 1 To $avatars[0]
									Local $valeurs = StringSplit($avatars[$j], "\")
									If Not @error And $valeurs[0] = 2 Then
										If $avatars_actualMenu[0] = 0 Or $avatars_actualMenu[1] <> $valeurs[1] Then
											Local $text = StringRegExpReplace($valeurs[1], "^\d+\s+-\s+", "")
											Local $menu = _GUICtrlCreateODMenu($text, $context)
											$avatars_menus[0] = $avatars_menus[0]+1
											ReDim $avatars_menus[$avatars_menus[0]+1]
											$avatars_menus[$avatars_menus[0]] = $menu
											$avatars_actualMenu[0] = $menu
											$avatars_actualMenu[1] = $valeurs[1]
										EndIf
										$avatars_menuitems[$j] = _GUICtrlCreateODMenuItem($valeurs[2], $avatars_actualMenu[0])
										_GUICtrlODMenuItemSetIcon($avatars_menuitems[$j], NAIO_images_folder()&"\Avatars\"&$avatars[$j]&".ico")
									Else
										$avatars_menuitems[$j] = _GUICtrlCreateODMenuItem("[Icone]", $context)
										_GUICtrlODMenuItemSetIcon($avatars_menuitems[$j], NAIO_images_folder()&"\Avatars\"&$avatars[$j]&".ico")
									EndIf
								Next
								If $avatars_menuitems[0]+$avatars_menus[0] > 0 Then
									$separator  = _GUICtrlCreateODMenuItem("",        $context)
									$erase_item = _GUICtrlCreateODMenuItem("Retirer", $context)
								EndIf
								; Affichage
								sousmenu($ORGANIZER_GUI, $msg, $context)
								Local $timer = TimerInit()
								Do
;~ 									Sleep(20)
									Local $submsg = GUIGetMsg()
								Until $submsg > 0 Or TimerDiff($timer) > 250
								; Traitement
								If $submsg = 0 Then
									; Rien
								ElseIf $submsg = $erase_item Then
									fenetre_icon($ORGANIZER_fenetres[$i], "")
									GUICtrlSetImage($msg, "shell32.dll", -295, 0)
								Else
									For $j = 1 To $avatars_menuitems[0]
										If $submsg = $avatars_menuitems[$j] Then
											fenetre_icon($ORGANIZER_fenetres[$i], $avatars[$j])
											GUICtrlSetImage($msg, "shell32.dll", -295, 0)
											Local $iconPath = NAIO_images_folder()&"\Avatars\"&fenetre_icon($ORGANIZER_fenetres[$i])&".ico"
											If FileExists($iconPath) Then
												GUICtrlSetImage($msg, $iconPath, -1)
												WinSetIcon(fenetre_handle($ORGANIZER_fenetres[$i]), $iconPath)
												WinSetState(fenetre_handle($ORGANIZER_fenetres[$i]), "", @SW_RESTORE)
											EndIf
											ExitLoop
										EndIf
									Next
								EndIf
								; Destruction
								For $j = 1 To $avatars_menuitems[0]
									If $avatars_menuitems[$j] <> 0 Then _GUICtrlODMenuItemDelete($avatars_menuitems[$j])
								Next
								For $j = 1 To $avatars_menus[0]
									If $avatars_menus[$j] <> 0 Then _GUICtrlODMenuItemDelete($avatars_menus[$j])
								Next
								If $avatars_menuitems[0]+$avatars_menus[0] > 0 Then
									_GUICtrlODMenuItemDelete($separator)
									_GUICtrlODMenuItemDelete($erase_item)
								EndIf
								GUICtrlDelete($context)
								GUICtrlDelete($dummy)
							EndIf
							registerMsg_ORGANIZER(GUICtrlGetHandle($msg))
						Case $ORGANIZER_labels[$i]
							unregisterMsg_ORGANIZER()
							WinActivate(fenetre_handle($ORGANIZER_fenetres[$i]))
							registerMsg_ORGANIZER(GUICtrlGetHandle($msg))
						Case $ORGANIZER_buttons[$i]
							unregisterMsg_ORGANIZER()
							Local $shortcut = ORGANIZER_catchShortcut(fenetre_shortcut($ORGANIZER_fenetres[$i]))
							If Not @error Then
								fenetre_shortcut($ORGANIZER_fenetres[$i], $shortcut)
								GUICtrlSetData($ORGANIZER_buttons[$i], shortcut_toString($shortcut, 1))
							EndIf
							registerMsg_ORGANIZER()
						Case $ORGANIZER_checkboxes[$i]
							unregisterMsg_ORGANIZER()
							Local $state = _GUICtrlGetCheck($ORGANIZER_checkboxes[$i])
							fenetre_activated($ORGANIZER_fenetres[$i], $state ? 1 : 0)
							registerMsg_ORGANIZER(GUICtrlGetHandle($msg))
						Case Else
							Local $valeur = Number(GUICtrlRead($ORGANIZER_inputs[$i]))
							If fenetre_order($ORGANIZER_fenetres[$i]) <> $valeur Then fenetre_order($ORGANIZER_fenetres[$i], $valeur)
					EndSwitch
				Next
		EndSwitch
	Until $quit Or $activate
	unregisterMsg_ORGANIZER()
	saveDataToConfigFile()
	GUIDelete($ORGANIZER_GUI)
	Return ($quit?"QUIT":"ACTIVATE")
EndFunc

Func registerMsg_ORGANIZER($control=0)
	GUIRegisterMsg(0x0020, "onHovering_ORGANIZER") ; $WM_SETCURSOR = 0x0020
	_onHovering_ORGANIZER($ORGANIZER_GUI, 0, $control, 0, True)
EndFunc

Func unregisterMsg_ORGANIZER()
	GUIRegisterMsg(0x0020, "") ; $WM_SETCURSOR = 0x0020
	_onHovering_ORGANIZER($ORGANIZER_GUI, 0, 0, 0, True)
	ToolTip("")
EndFunc

Func onHovering_ORGANIZER($handle, $msg, $wParam, $lParam)
	Return _onHovering_ORGANIZER($handle, $msg, $wParam, $lParam, False)
EndFunc

Func _onHovering_ORGANIZER($handle, $msg, $wParam, $lParam, $force = False)
	If Not IsDeclared("previous_over_ORGANIZER") Then Global $previous_over_ORGANIZER = 0
	Local $hovercolor = 0xDDDDDD, $unhovercolor = -2 ; $GUI_BKCOLOR_TRANSPARENT = -2
	If $force = True Or $previous_over_ORGANIZER <> $wParam Then
		Local $actual_over_ORGANIZER = $wParam, $position = WinGetPos($ORGANIZER_GUI), $tip[3] = [($handle = $ORGANIZER_GUI), $position[0]+$position[2]/2, $position[1]+$position[3]-10]
		; Unhover
		; Rien
		; Hover
		Local $found = False
		If Not $found Then
			$found = True
			Switch $actual_over_ORGANIZER
				Case GUICtrlGetHandle($ORGANIZER_titre)
					If $tip[0] Then ToolTip("Drag'n'drop pour dplacer la fentre", $tip[1], $tip[2], field("name")&" v"&field("version"), 0, 3)
				Case GUICtrlGetHandle($ORGANIZER_quitter)
					If $tip[0] Then ToolTip("Cliquez pour fermer la configuration"&@CRLF&"et activer les raccourcis", $tip[1], $tip[2], "Quitter", 0, 3)
				Case GUICtrlGetHandle($ORGANIZER_buttonPrevious)
					If $tip[0] Then ToolTip("Cliquez pour "&($ORGANIZER_commandes[1]=""?"ajouter un raccourci":"modifier le raccourci :"&@CRLF&"< "&shortcut_toString($ORGANIZER_commandes[1])&" >"&@CRLF&"(clic droit pour le supprimer)"), $tip[1], $tip[2], "Fentre prcdente", 0, 3)
				Case GUICtrlGetHandle($ORGANIZER_buttonNext)
					If $tip[0] Then ToolTip("Cliquez pour "&($ORGANIZER_commandes[2]=""?"ajouter un raccourci":"modifier le raccourci :"&@CRLF&"< "&shortcut_toString($ORGANIZER_commandes[2])&" >"&@CRLF&"(clic droit pour le supprimer)"), $tip[1], $tip[2], "Fentre suivante", 0, 3)
				Case GUICtrlGetHandle($ORGANIZER_buttonRefresh)
					If $tip[0] Then ToolTip("Cliquez pour mettre  jour la liste des"&@CRLF&"fentres et les trier en fonction de l'initiative", $tip[1], $tip[2], "Rafrachir la liste", 0, 3)
				Case Else
					$found = False
			EndSwitch
		EndIf
		If Not $found Then
			For $i = 1 To $ORGANIZER_fenetres[0]
				If Not $found Then
					$found = True
					Switch $actual_over_ORGANIZER
						Case GUICtrlGetHandle($ORGANIZER_icons[$i])
							If $tip[0] Then ToolTip("Cliquez pour changer d'avatar", $tip[1], $tip[2], fenetre_alias($ORGANIZER_fenetres[$i])&" (Avatar)", 0, 3)
						Case GUICtrlGetHandle($ORGANIZER_labels[$i])
							If $tip[0] Then ToolTip("Cliquez pour activer la fentre", $tip[1], $tip[2], fenetre_alias($ORGANIZER_fenetres[$i]), 0, 3)
						Case GUICtrlGetHandle($ORGANIZER_inputs[$i])
							If $tip[0] Then ToolTip("Initiative du personnage de la fentre"&@CRLF&"(utile pour rorganiser les fentres)", $tip[1], $tip[2], fenetre_alias($ORGANIZER_fenetres[$i])&" (Initiative)", 0, 3)
						Case GUICtrlGetHandle($ORGANIZER_buttons[$i])
							If $tip[0] Then ToolTip("Cliquez pour "&(fenetre_shortcut($ORGANIZER_fenetres[$i])=""?"ajouter un raccourci":"modifier le raccourci :"&@CRLF&"< "&shortcut_toString(fenetre_shortcut($ORGANIZER_fenetres[$i]))&" >"&@CRLF&"Clic droit pour le supprimer"), $tip[1], $tip[2], fenetre_alias($ORGANIZER_fenetres[$i])&" (Raccourci)", 0, 3)
						Case GUICtrlGetHandle($ORGANIZER_checkboxes[$i])
							If $tip[0] Then ToolTip((fenetre_activated($ORGANIZER_fenetres[$i])=1 ? "Cliquez pour dcocher et"&@CRLF&"ignorer la fentre lors du cycle" : "Cliquez pour cocher et prendre en"&@CRLF&"compte la fentre lors du cycle"), $tip[1], $tip[2], fenetre_alias($ORGANIZER_fenetres[$i])&" (Activation)", 0, 3)
						Case Else
							$found = False
					EndSwitch
				EndIf
			Next
		EndIf
		If Not $found Then ToolTip("")
		$previous_over_ORGANIZER = $actual_over_ORGANIZER
	EndIf
	Return "GUI_RUNDEFMSG" ; $GUI_RUNDEFMSG = "GUI_RUNDEFMSG"
EndFunc

Func saveDataToConfigFile()
	Local $file = ORGANIZER_config_file(), $section = ORGANIZER_profil()
	IniWrite($file, $section, "PositionX", $ORGANIZER_GUI_position[0])
	IniWrite($file, $section, "PositionX", $ORGANIZER_GUI_position[0])
	IniWrite($file, $section, "PositionY", $ORGANIZER_GUI_position[1])
	IniWrite($file, $section, "Previous",  $ORGANIZER_commandes[1])
	IniWrite($file, $section, "Next",      $ORGANIZER_commandes[2])
	For $i = 1 To $ORGANIZER_fenetres[0]
		Local $fenetre = $ORGANIZER_fenetres[$i]
		IniWrite($file, $section, "_"&fenetre_alias($fenetre), Number(fenetre_order($fenetre))&""&Number(fenetre_activated($fenetre))&""&fenetre_shortcut($fenetre)&""&fenetre_icon($fenetre))
	Next
EndFunc

Func loadDataFromConfigFile()
	Local $file = ORGANIZER_config_file(), $section = ORGANIZER_profil()
	Local $vide[1][2] = [[0]], $resultat = IniReadSection($file, $section)
	If @error Then Return $vide
	Return $resultat
EndFunc

Func ORGANIZER_refresh($sort=True)
	saveDataToConfigFile()
	GUICtrlSetState($ORGANIZER_buttonRefresh, 0x80) ; $GUI_DISABLE = 0x80
	For $i = 1 To $ORGANIZER_fenetres[0]
		GUICtrlDelete($ORGANIZER_icons[$i])
		GUICtrlDelete($ORGANIZER_labels[$i])
		GUICtrlDelete($ORGANIZER_inputs[$i])
		GUICtrlDelete($ORGANIZER_buttons[$i])
		GUICtrlDelete($ORGANIZER_checkboxes[$i])
	Next
	Local $old_position = WinGetPos($ORGANIZER_GUI)
	WinMove($ORGANIZER_GUI, "", $old_position[0], $old_position[1], $old_position[2], $old_position[3]-25*$ORGANIZER_fenetres[0])
	$ORGANIZER_fenetres = ORGANIZER_getWinList()
	Local $new_position = WinGetPos($ORGANIZER_GUI)
	WinMove($ORGANIZER_GUI, "", $new_position[0], $new_position[1], $new_position[2], $new_position[3]+25*$ORGANIZER_fenetres[0])
	Local $elements[$ORGANIZER_fenetres[0]+1] = [$ORGANIZER_fenetres[0]]
	$ORGANIZER_icons      = $elements
	$ORGANIZER_labels     = $elements
	$ORGANIZER_inputs     = $elements
	$ORGANIZER_buttons    = $elements
	$ORGANIZER_checkboxes = $elements
	GUICtrlSetState($ORGANIZER_nothing,            ($ORGANIZER_fenetres[0]<>0 ? 0x20 : 0x10)) ; $GUI_HIDE = 0x20 ; $GUI_SHOW = 0x10
	GUICtrlSetState($ORGANIZER_icons_header,       ($ORGANIZER_fenetres[0]<>0 ? 0x10 : 0x20)) ; $GUI_SHOW = 0x10 ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_labels_header,      ($ORGANIZER_fenetres[0]<>0 ? 0x10 : 0x20)) ; $GUI_SHOW = 0x10 ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_inputs_header,      ($ORGANIZER_fenetres[0]<>0 ? 0x10 : 0x20)) ; $GUI_SHOW = 0x10 ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_buttons_header,     ($ORGANIZER_fenetres[0]<>0 ? 0x10 : 0x20)) ; $GUI_SHOW = 0x10 ; $GUI_HIDE = 0x20
	GUICtrlSetState($ORGANIZER_checkboxes_header,  ($ORGANIZER_fenetres[0]<>0 ? 0x10 : 0x20)) ; $GUI_SHOW = 0x10 ; $GUI_HIDE = 0x20
	For $i = 1 To $ORGANIZER_fenetres[0]
		Local $handle = fenetre_handle($ORGANIZER_fenetres[$i])
		$ORGANIZER_icons[$i]      = GUICtrlCreateIcon("shell32.dll", -295, 12, 47+25*$i,    16, 16)
		$ORGANIZER_labels[$i]     = GUICtrlCreateLabel("",                 40, 45+25*$i+3, 105, 15, 0x0001) ; $ES_CENTER = 0x0001
		$ORGANIZER_inputs[$i]     = GUICtrlCreateInput("",                155, 45+25*$i,    55, 20, 0x0001) ; $ES_CENTER = 0x0001
		$ORGANIZER_buttons[$i]    = GUICtrlCreateButton("",               220, 45+25*$i,    80, 20)
		$ORGANIZER_checkboxes[$i] = GUICtrlCreateCheckbox("",             310, 45+25*$i,    20, 20)
		GUICtrlSetBkColor($ORGANIZER_icons[$i],    0xff9900)
		GUICtrlSetState($ORGANIZER_icons[$i],      0x80) ; $GUI_DISABLE = 0x80
		GUICtrlSetState($ORGANIZER_buttons[$i],    0x80) ; $GUI_DISABLE = 0x80
		GUICtrlSetState($ORGANIZER_checkboxes[$i], 0x80) ; $GUI_DISABLE = 0x80
		Local $iconPath = NAIO_images_folder()&"\Avatars\"&fenetre_icon($ORGANIZER_fenetres[$i])&".ico"
		If FileExists($iconPath) Then
			GUICtrlSetImage($ORGANIZER_icons[$i], $iconPath, -1)
			WinSetIcon(fenetre_handle($ORGANIZER_fenetres[$i]), $iconPath)
			WinSetState(fenetre_handle($ORGANIZER_fenetres[$i]), "", @SW_RESTORE)
		Else
			WinSetIcon(fenetre_handle($ORGANIZER_fenetres[$i]), ORGANIZER_folder()&"\Images\Defaut.ico")
			WinSetState(fenetre_handle($ORGANIZER_fenetres[$i]), "", @SW_RESTORE)
		EndIf
		GUICtrlSetData($ORGANIZER_labels[$i],      fenetre_alias($ORGANIZER_fenetres[$i]))
		GUICtrlSetData($ORGANIZER_inputs[$i],      fenetre_order($ORGANIZER_fenetres[$i]))
		GUICtrlSetData($ORGANIZER_buttons[$i],     shortcut_toString(fenetre_shortcut($ORGANIZER_fenetres[$i]), 1))
		GUICtrlSetState($ORGANIZER_checkboxes[$i], fenetre_activated($ORGANIZER_fenetres[$i]) ? 0x01 : 0x04) ; $GUI_CHECKED = 0x01 ; $GUI_UNCHECKED = 0x04
		GUICtrlSetBkColor($ORGANIZER_labels[$i],   -2) ; $GUI_BKCOLOR_TRANSPARENT = -2
		; Positionnement
		GUICtrlSetResizing($ORGANIZER_icons[$i],      0x0102 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKWIDTH = 0x0100 ; $GUI_DOCKTOP = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
		GUICtrlSetResizing($ORGANIZER_labels[$i],     0x0006 + 0x0220) ; $GUI_DOCKLEFT  = 0x0002 ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKTOP = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
		GUICtrlSetResizing($ORGANIZER_inputs[$i],     0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH = 0x0100 ; $GUI_DOCKTOP = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
		GUICtrlSetResizing($ORGANIZER_buttons[$i],    0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH = 0x0100 ; $GUI_DOCKTOP = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
		GUICtrlSetResizing($ORGANIZER_checkboxes[$i], 0x0104 + 0x0220) ; $GUI_DOCKRIGHT = 0x0004 ; $GUI_DOCKWIDTH = 0x0100 ; $GUI_DOCKTOP = 0x0020 ; $GUI_DOCKHEIGHT = 0x0200
	Next
	; Rorganisation
	If $sort Then
		Local $tempTray = _TrayIconCreate(field("name")&" v"&field("version"), @ScriptFullPath)
		; Affichage
		_TrayIconSetClick($tempTray, 0) ; Aucune action possible
		_TrayIconSetState($tempTray, 1)
		For $i = 1 To $ORGANIZER_fenetres[0]
			_TrayTip($tempTray, field("name")&" v"&field("version")&" - "&"Tri", "Veuillez patienter pendant le tri ("&$i&" sur "&$ORGANIZER_fenetres[0]&") ...", 10, 2)
			Local $handle = fenetre_handle($ORGANIZER_fenetres[$i])
			WinSetState($handle, "", @SW_HIDE)
			WinSetState($handle, "", @SW_SHOW)
			GUICtrlSetState($ORGANIZER_icons[$i],      0x40) ; $GUI_ENABLE = 0x40
			GUICtrlSetState($ORGANIZER_buttons[$i],    0x40) ; $GUI_ENABLE = 0x40
			GUICtrlSetState($ORGANIZER_checkboxes[$i], 0x40) ; $GUI_ENABLE = 0x40
		Next
		_TrayTip($tempTray, "", "")
		_TrayIconDelete($tempTray)
	Else
		For $i = 1 To $ORGANIZER_fenetres[0]
			GUICtrlSetState($ORGANIZER_icons[$i],      0x40) ; $GUI_ENABLE = 0x40
			GUICtrlSetState($ORGANIZER_buttons[$i],    0x40) ; $GUI_ENABLE = 0x40
			GUICtrlSetState($ORGANIZER_checkboxes[$i], 0x40) ; $GUI_ENABLE = 0x40
		Next
	EndIf
	GUICtrlSetState($ORGANIZER_buttonRefresh, 0x40) ; $GUI_ENABLE = 0x40
EndFunc

Func ORGANIZER_getWinList()
	Local $resultat[1] = [0]
	; Liste des fentres ligibles
	Local $patternDofus = IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "PatternDofus", "[REGEXPCLASS:^(?i)ApolloRuntimeContentWindow$]")
	Local $processDofus = IniRead(ORGANIZER_config_file(), ORGANIZER_profil(), "RegexpDofus",  "^(?i)dofus[^\.]*\.exe$")
	Local $winList = WinList($patternDofus), $processList = ProcessList()
	For $i = 1 To $winList[0][0]
		Local $handle = $winList[$i][1], $pid = WinGetProcess($handle)
		If BitAND(WinGetState($handle), 2) Then
			If $pid > 0 Then
				For $j = 1 To $processList[0][0]
					If $processList[$j][1] = $pid And (StringLower($processList[$j][0]) = StringLower($processDofus) Or StringRegExp($processList[$j][0], $processDofus)) Then
						Local $fenetre = fenetre_new()
						fenetre_alias($fenetre,  WinGetTitle($handle))
						fenetre_handle($fenetre, $handle)
						$resultat[0] = $resultat[0]+1
						ReDim $resultat[$resultat[0]+1]
						$resultat[$resultat[0]] = $fenetre
						ExitLoop
					EndIf
				Next
			EndIf
		EndIf
	Next
	If $resultat[0] > 0 Then
		fenetres_generateIndex($resultat)
		; Liste des ressources disponibles
		Local $patternData = "^(\d+)(\d)([^]*)([^]*)$"
		Local $ressources = loadDataFromConfigFile()
		; Association ressources-fentres
		Local $association[$resultat[0]+1][3] = [[$resultat[0]]]
		For $i = 1 To $resultat[0]
			$association[$i][0] = 0
			$association[$i][1] = $resultat[$i]
			Local $found = "", $name = fenetre_alias($resultat[$i])
			For $j = 1 To $ressources[0][0]
				If $found = "" And $ressources[$j][0] = "_"&$name Then $found = $ressources[$j][1]
			Next
			If $found <> "" Then
				Local $order     = Number(StringRegExpReplace($found, $patternData, "$1"))
				Local $activated = Number(StringRegExpReplace($found, $patternData, "$2"))
				Local $shortcut  = StringRegExpReplace($found,        $patternData, "$3")
				Local $icon      = StringRegExpReplace($found,        $patternData, "$4")
				fenetre_order($resultat[$i],     $order)
				fenetre_activated($resultat[$i], $activated)
				fenetre_shortcut($resultat[$i],  $shortcut)
				fenetre_icon($resultat[$i],      $icon)
				$association[$i][0] = $order
			EndIf
		Next
		; Tri de la liste
		_ArraySort($association, 1, 1)
		; Rorganisation
		For $i = 1 To $resultat[0]
			$resultat[$i] = $association[$i][1]
		Next
	EndIf
	Return $resultat
EndFunc

; ### Region Gestion des raccourcis

Func ORGANIZER_detectShortcut()
	Local $found = False, $fenetres = $ORGANIZER_fenetres
	For $i = 1 To $fenetres[0]
		If @HotKeyPressed = fenetre_shortcut($fenetres[$i]) Then
			Local $index = Mod(($i)-1, $fenetres[0])+1
			WinActivate(fenetre_handle($fenetres[$index]))
			ExitLoop
		EndIf
	Next
EndFunc

Func ORGANIZER_detectShortcut_previous()
	ORGANIZER_detectShortcut_cycle(-1, @HotKeyPressed, "ORGANIZER_detectShortcut_previous")
EndFunc

Func ORGANIZER_detectShortcut_next()
	ORGANIZER_detectShortcut_cycle(+1, @HotKeyPressed, "ORGANIZER_detectShortcut_next")
EndFunc

Func ORGANIZER_detectShortcut_cycle($direction, $shortcut, $function)
	Local $found = False, $fenetres = $ORGANIZER_fenetres
	For $i = 1 To $fenetres[0]
		If WinActive(fenetre_handle($fenetres[$i])) Then
			Local $index = $i
			Do
				$index = $index+$direction
				If $index < 1 Then $index = $fenetres[0]
				If $index > $fenetres[0] Then $index = 1
				$found = $index <> $i And WinExists(fenetre_handle($fenetres[$index])) And fenetre_activated($fenetres[$index])
				If $found Then WinActivate(fenetre_handle($fenetres[$index]))
			Until $index = $i Or $found
			ExitLoop
		EndIf
	Next
	If Not $found Then
		HotKeySet($shortcut)
		Send($shortcut)
		HotKeySet($shortcut, $function)
	EndIf
EndFunc

; ### Enregistrement d'un nouveau raccourci

Func ORGANIZER_catchShortcut($parameter="")
	; Initialisation
	Local $shortcut = $parameter
	; Cration des lments graphiques
	Local $CATCH_GUI_size[2] = [160,120], $CATCH_GUI_position[2] = [Default, Default], $parent_position = WinGetPos($ORGANIZER_GUI)
	If Not @error Then
		$CATCH_GUI_position[0] = $parent_position[0]+($parent_position[2]-$CATCH_GUI_size[0])/2
		$CATCH_GUI_position[1] = $parent_position[1]+($parent_position[3]-$CATCH_GUI_size[1])/2
	EndIf
	Local $CATCH_GUI = GUICreate(field("name")&" v"&field("version"), $CATCH_GUI_size[0], $CATCH_GUI_size[1], $CATCH_GUI_position[0], $CATCH_GUI_position[1], 0x80800000, 0x00000010, $ORGANIZER_GUI) ; $WS_POPUP = 0x80000000 ; $WS_BORDER = 0x00800000 ; $WS_EX_ACCEPTFILES = 0x00000010
	Local $CATCH_button = GUICtrlCreateButton("", 5, 5, $CATCH_GUI_size[0]-10, $CATCH_GUI_size[1]-35, 0x2000) ; $BS_MULTILINE = 0x2000
	Local $CATCH_input  = GUICtrlCreateInput("", 30, $CATCH_GUI_size[1]-25, $CATCH_GUI_size[0]-60, 20, 0x0001) ; $ES_CENTER = 0x0001
	Local $CATCH_erase  = GUICtrlCreateButton("X", 5, $CATCH_GUI_size[1]-25, 20, 20)
	Local $CATCH_valid  = GUICtrlCreateButton(">", $CATCH_GUI_size[0]-25, $CATCH_GUI_size[1]-25, 20, 20)
	; Habillage
	Local $test = shortcut_toString($shortcut)
	GUICtrlSetData($CATCH_button, "Raccourci actuel :"&@CRLF&$test&@CRLF&@CRLF&"Tapez le raccourci ou"&@CRLF&"cliquez pour annuler")
	GUICtrlSetData($CATCH_input,  $shortcut)
	GUICtrlSetState($CATCH_input, 0x80) ; $GUI_DISABLE = 0x80
	; Affichage
	GUISetState(@SW_SHOW, $CATCH_GUI)
	Local $stop = False, $valid = False, $process = True, $previous = ""
	Do
		; Focus
		If Not WinActive($CATCH_GUI) Then $stop = True
		; Traitement
;~ 		Sleep(20)
		Local $msg = GUIGetMsg()
		Switch $msg
			Case $CATCH_button
				If $process Then
					Local $test = shortcut_toString($shortcut)
					GUICtrlSetData($CATCH_button, "Raccourci actuel :"&@CRLF&$test&@CRLF&"Cliquez pour "&(@error?"ajouter":"modifier"))
					GUICtrlSetData($CATCH_input,  $shortcut)
					GUICtrlSetState($CATCH_input, 0x40) ; $GUI_ENABLE = 0x40
					$process = False
				Else
					Local $test = shortcut_toString($shortcut)
					GUICtrlSetData($CATCH_button, "[Actuel:"&$test&"]"&@CRLF&"Tapez le raccourci ou"&@CRLF&"cliquez pour annuler")
					GUICtrlSetData($CATCH_input,  $shortcut)
					GUICtrlSetState($CATCH_input, 0x80) ; $GUI_DISABLE = 0x80
					$process = True
				EndIf
			Case $CATCH_valid
				$valid = True
			Case $CATCH_erase
				GUICtrlSetData($CATCH_input, "")
				$valid = True
			Case Else
				If $process Then
					Local $value = ""
					For $code = 0x08 To 0xFF
						If ORGANIZER_catchShortcut_checkKey($code) Then
							$value = ORGANIZER_catchShortcut_decodeKey($code)
							If Not @error Then ExitLoop
						EndIf
					Next
					If $previous <> $value Then
						If $value = "" Then
							Local $shortcut = "" _
								& (ORGANIZER_catchShortcut_checkKey(0x11) ? "^" : "") _ ; Control
								& (ORGANIZER_catchShortcut_checkKey(0x12) ? "!" : "") _ ; Alt
								& (ORGANIZER_catchShortcut_checkKey(0x10) ? "+" : "") _ ; Shift
								& (ORGANIZER_catchShortcut_checkKey(0x5B) ? "#" : "") _ ; Windows
								& "{"&$previous&"}"             ; Touche
							Local $test = shortcut_toString($shortcut)
							GUICtrlSetData($CATCH_button, "Raccourci actuel :"&@CRLF&$test&@CRLF&"Cliquez pour "&(@error?"ajouter":"modifier"))
							GUICtrlSetData($CATCH_input,  $shortcut)
							GUICtrlSetState($CATCH_input, 0x40) ; $GUI_ENABLE = 0x40
							$process = False
						EndIf
						$previous = $value
					EndIf
				EndIf
		EndSwitch
	Until $stop Or $valid
	$shortcut = GUICtrlRead($CATCH_input)
	GUIDelete($CATCH_GUI)
	Return ($valid?$shortcut:$parameter)
EndFunc

Func ORGANIZER_catchShortcut_checkKey($code)
	Local $resultat = DllCall($USER32_DLL, "int", "GetAsyncKeyState", "int", $code)
	Return Not @error And BitAND($resultat[0], 0x8000) = 0x8000
EndFunc

Func ORGANIZER_catchShortcut_decodeKey($code)
	If $code = 0x08 Then Return "BS"
	If $code = 0x09 Then Return "TAB"
	If $code = 0x13 Then Return "PAUSE"
	If $code = 0x1B Then Return "ESC"
	If $code = 0x20 Then Return "SPACE"
	If $code = 0x21 Then Return "PGUP"
	If $code = 0x22 Then Return "PGDN"
	If $code = 0x23 Then Return "END"
	If $code = 0x24 Then Return "HOME"
	If $code = 0x25 Then Return "LEFT"
	If $code = 0x26 Then Return "UP"
	If $code = 0x27 Then Return "RIGHT"
	If $code = 0x28 Then Return "DOWN"
	If $code = 0x2C Then Return "PRINTSCREEN"
	If $code = 0x2D Then Return "INS"
	If $code = 0x2E Then Return "DEL"
	If $code = 0x6A Then Return "NUMPADMULT"
	If $code = 0x6B Then Return "NUMPADADD"
	If $code = 0x6D Then Return "NUMPADSUB"
	If $code = 0x6E Then Return "NUMPADDOT"
	If $code = 0x6F Then Return "NUMPADDIV"
	If $code = 0xDE Then Return ""
	If $code = 0xDB Then Return ")"
	If $code = 0xBB Then Return "="
	If $code = 0xDD Then Return "^"
	If $code = 0xBA Then Return "$"
	If $code = 0xC0 Then Return ""
	If $code = 0xDC Then Return "*"
	If $code = 0xBC Then Return ","
	If $code = 0xBE Then Return ";"
	If $code = 0xBF Then Return ":"
	If $code = 0xDF Then Return "!"
	If $code = 0xE2 Then Return "<"
	If $code = 0x30 Then Return ""
	If $code = 0x31 Then Return "&"
	If $code = 0x32 Then Return ""
	If $code = 0x33 Then Return """"
	If $code = 0x34 Then Return "'"
	If $code = 0x35 Then Return "("
	If $code = 0x36 Then Return "-"
	If $code = 0x37 Then Return ""
	If $code = 0x38 Then Return "_"
	If $code = 0x39 Then Return ""
	If $code >= 0x41 And $code <= 0x5A Then Return StringLower(Chr($code))
	If $code >= 0x60 And $code <= 0x69 Then Return "NUMPAD"&Number($code-0x60)
	If $code >= 0x70 And $code <= 0x87 Then Return "F"&Number($code-0x6F)
	; Eviter de traiter les commandes primitives
;~ 	If $code = 0x0D Then Return "Enter"
;~ 	If $code = 0x29 Then Return "Select"
;~ 	If $code = 0x2A Then Return "Print"
;~ 	If $code = 0x2B Then Return "Execute"
	; Eviter les touches intraitables par HotKey
;~ 	If $code = 0x6C Then Return "Separator"
	; Eviter de traiter les commandes souris (privilgier les raccourcis cabls sur les boutons)
;~ 	If $code = 0x01 Then Return "MouseLeft"
;~ 	If $code = 0x02 Then Return "MouseRight"
;~ 	If $code = 0x04 Then Return "MouseMiddle"
;~ 	If $code = 0x05 Then Return "MouseX1"
;~ 	If $code = 0x06 Then Return "MouseX2"
	; Ne pas du tout traiter les modificateurs (utiliser dans une autre fonction pour scruter l'tat)
;~ 	If $code = 0x10 Then Return "Shift"
;~ 	If $code = 0x11 Then Return "Control"
;~ 	If $code = 0x12 Then Return "Alt"
;~ 	If $code = 0x5B Then Return "WindowsLeft"
;~ 	If $code = 0x5C Then Return "WindowsRight"
;~ 	If $code = 0xA0 Then Return "ShiftLeft"
;~ 	If $code = 0xA1 Then Return "ShiftRight"
;~ 	If $code = 0xA2 Then Return "ControlLeft"
;~ 	If $code = 0xA3 Then Return "ControlRight"
;~ 	If $code = 0xA4 Then Return "MenuLeft"
;~ 	If $code = 0xA5 Then Return "MenuRight"
;~ 	If $code = 0x14 Then Return "CapsLock"
;~ 	If $code = 0x90 Then Return "NumLock"
;~ 	If $code = 0x91 Then Return "ScrollLock"
	Return SetError(1, 0, "")
EndFunc

; ### Region Dossiers des ressources

Func NAIO_folder($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("NAIO_folder")
	If Not $declared Or $reset Then
		If Not $declared Then Global $NAIO_folder
		$NAIO_folder = StringRegExpReplace(@ScriptDir, "\\[^\\]*$", "")
	EndIf
	Local $resultat = $NAIO_folder
	If @NumParams > 0 And Not $reset Then $NAIO_folder = $value
	Return $resultat
EndFunc

Func NAIO_images_folder()
	Return NAIO_folder()&"\Images"
EndFunc

Func ORGANIZER_folder($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("ORGANIZER_folder")
	If Not $declared Or $reset Then
		If Not $declared Then Global $ORGANIZER_folder
		$ORGANIZER_folder = @ScriptDir&"\"&field("name")
	EndIf
	Local $resultat = $ORGANIZER_folder
	If @NumParams > 0 And Not $reset Then $ORGANIZER_folder = $value
	Return $resultat
EndFunc

; ### Region Fichiers des ressources

Func ORGANIZER_config_file($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("ORGANIZER_config_file")
	If Not $declared Or $reset Then
		If Not $declared Then Global $ORGANIZER_config_file
		$ORGANIZER_config_file = ORGANIZER_folder()&"\"&field("name")&"."&"ini"
	EndIf
	Local $resultat = $ORGANIZER_config_file
	If @NumParams > 0 And Not $reset Then $ORGANIZER_config_file = $value
	Return $resultat
EndFunc

Func ORGANIZER_debug_file()
	Return ORGANIZER_folder()&"\"&field("name")&"-"&"Logs.txt"
EndFunc

; ### Region Chargement des ressources

Func NAIO_avatars($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("NAIO_avatars")
	If Not $declared Or $reset Then
		If Not $declared Then Global $NAIO_avatars
		Local $vide[1] = [0], $size = 0
		$NAIO_avatars = $vide
		; Dossiers
		Local $dossiers = listFolders(NAIO_images_folder()&"\Avatars\", "*")
		If @error Then $dossiers = $vide
		For $i = 1 To $dossiers[0]
			$dossiers[$i] = $dossiers[$i]&"\"
		Next
		$dossiers[0] = $dossiers[0]+1
		ReDim $dossiers[$dossiers[0]+1]
		$dossiers[$dossiers[0]] = ""
		For $i = 1 To $dossiers[0]
			; Fichiers de chaque dossier
			Local $files = listFiles(NAIO_images_folder()&"\Avatars\"&$dossiers[$i], "*.ico")
			If @error Then $files = $vide
			For $j = 1 To $files[0]
				$NAIO_avatars[0] = $NAIO_avatars[0]+1
				ReDim $NAIO_avatars[$NAIO_avatars[0]+1]
				$NAIO_avatars[$NAIO_avatars[0]] = $dossiers[$i]&StringTrimRight($files[$j], StringLen(".ico"))
			Next
		Next
	EndIf
	Local $resultat = $NAIO_avatars
	If @NumParams > 0 And Not $reset Then $NAIO_avatars = $value
	Return $resultat
EndFunc

Func ORGANIZER_profil($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("ORGANIZER_profil")
	If Not $declared Or $reset Then
		If Not $declared Then Global $ORGANIZER_profil
		$ORGANIZER_profil = "Organizer"
		For $i = 1 To $CmdLine[0]-1
			If StringRegExp($CmdLine[$i], "^(?i)(-|/)(profil)$") Then $ORGANIZER_profil = $CmdLine[$i+1]
		Next
	EndIf
	Local $resultat = $ORGANIZER_profil
	If @NumParams > 0 And Not $reset Then $ORGANIZER_profil = $value
	Return $ORGANIZER_profil
EndFunc

Func ORGANIZER_msg($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("ORGANIZER_msg")
	If Not $declared Or $reset Then
		If Not $declared Then Global $ORGANIZER_msg
		$ORGANIZER_msg = 0
	EndIf
	Local $resultat = $ORGANIZER_msg
	If @NumParams > 0 And Not $reset Then $ORGANIZER_msg = $value
	Return $resultat
EndFunc

; ### Region Fonctions annexes

Func shortcut_toString($shortcut, $simple=0)
	Local $resultat = "", $erreur = 0, $patternShortcut = "^([\^!\+#]*)\{(.+)\}$"
	If $shortcut = "" Then
		$resultat = ($simple<>1?"Aucun raccourci":"Aucun")
		$erreur = 1
	ElseIf Not StringRegExp($shortcut, $patternShortcut) Then
		ConsoleWrite("RegExp error : '"&$shortcut&"'"&@CRLF)
		$resultat = ($simple<>1?"Raccourci inconnu":"Inconnu")
		$erreur = 2
	Else
		Local $modifiers = StringRegExpReplace($shortcut, $patternShortcut, "$1"), $value = StringRegExpReplace($shortcut, $patternShortcut, "$2")
		$modifiers = StringReplace($modifiers, "^", ($simple<>0?"c":"Control"))
		$modifiers = StringReplace($modifiers, "!", ($simple<>0?"a":"Alt"))
		$modifiers = StringReplace($modifiers, "+", ($simple<>0?"s":"Shift"))
		$modifiers = StringReplace($modifiers, "#", ($simple<>0?"w":"Windows"))
		$resultat = $modifiers&($modifiers=""?"":" ")&"["&StringUpper($value)&"]"
	EndIf
	Return SetError($erreur, 0, $resultat)
EndFunc

Func shortcutKey_toString($shortcut)
	Local $value = StringRegExpReplace($shortcut, "^\{(.*)\}$", "$1")
	If $value = ""            Then Return ""
	If $value = "BS"          Then Return "Backspace"
	If $value = "TAB"         Then Return "Tabulation"
	If $value = "PAUSE"       Then Return "Pause"
	If $value = "ESC"         Then Return "Echap"
	If $value = "SPACE"       Then Return "Escpace"
	If $value = "PGUP"        Then Return "PageUp"
	If $value = "PGDN"        Then Return "PageDown"
	If $value = "END"         Then Return "End"
	If $value = "HOME"        Then Return "Home"
	If $value = "LEFT"        Then Return "Gauche"
	If $value = "UP"          Then Return "Haut"
	If $value = "RIGHT"       Then Return "Droite"
	If $value = "DOWN"        Then Return "Bas"
	If $value = "PRINTSCREEN" Then Return "PrintScreen"
	If $value = "INS"         Then Return "Insert"
	If $value = "DEL"         Then Return "Delete"
	If $value = "NUMPADMULT"  Then Return "Multiplier"
	If $value = "NUMPADADD"   Then Return "Plus"
	If $value = "NUMPADSUB"   Then Return "Moins"
	If $value = "NUMPADDOT"   Then Return "Point"
	If $value = "NUMPADDIV"   Then Return "Diviser"
	If $value = ""           Then Return "Carr"
	If $value = ")"           Then Return ")"
	If $value = "="           Then Return "="
	If $value = "^"           Then Return "^"
	If $value = "$"           Then Return "$"
	If $value = ""           Then Return ""
	If $value = "*"           Then Return "*"
	If $value = ","           Then Return ","
	If $value = ";"           Then Return ";"
	If $value = ":"           Then Return ":"
	If $value = "!"           Then Return "!"
	If $value = "<"           Then Return "<"
	If $value = ""           Then Return ""
	If $value = "&"           Then Return "&"
	If $value = ""           Then Return ""
	If $value = """"          Then Return """"
	If $value = "'"           Then Return "'"
	If $value = "("           Then Return "("
	If $value = "-"           Then Return "-"
	If $value = ""           Then Return ""
	If $value = "_"           Then Return "_"
	If $value = ""           Then Return ""
	If StringRegExp($value, "[a-zA-Z]") Then Return StringUpper($value)
	If StringRegExp($value, "NUMPAD\d") Then Return $value
	If StringRegExp($value, "F\d+")     Then Return $value
	Return SetError(1, 0, "Custom")
EndFunc

Func WinSetIcon($handle, $file, $index = 0)
    Local $struct = DllStructCreate("ptr Data")
    DllCall("shell32.dll", "uint", "ExtractIconExW", "wstr", $file, "int", $index, "struct*", 0, "struct*", $struct, "uint", 1)
    If @error Then Return SetError(1, 0, 0)
    Local $icon = DllStructGetData($struct, "Data")
   _SendMessage($handle, 0x0080, 1, $icon) ; $WM_SETICON = 0x0080
   _WinAPI_DestroyIcon($icon)
EndFunc
