#Include-Once

; ### Region Fonctions diverses

; Smaphore
Func singleton()
	Local $resultat = _Semaphore_BlockerInit(@ScriptName)
	Return @error = 0 And @extended = 0
EndFunc

; Informations de base - $key = [name|type|version|fullversion|author|comment|url]
Func field($key, $val="")
	Local $fields = NAIO_fields()
	Local $resultat = quickget($fields, $key)
	If @NumParams > 1 And Not @error Then
		$fields[@extended][1] = $val
		NAIO_fields($fields)
	EndIf
	Return $resultat
EndFunc

; Tri rapide des tableaux
Func quicksort(ByRef $array, $start="", $end="")
	$start = (IsInt($start) ? $start : 1)
	$end   = (IsInt($end)   ? $end   : UBound($array)-1)
	If $end > $start Then
		Local $start2=$start, $end2=$end, $middle = Int(($start2+$end2)/2), $pivot = $array[$middle][0]
		Do
			While (StringCompare($array[$start2][0], $pivot, 2) < 0) And $start2 <= $end2
				$start2 += 1
			WEnd
			While (StringCompare($array[$end2][0], $pivot, 2) > 0) And $start2 <= $end2
				$end2 -= 1
			WEnd
			If $start2 <= $end2 Then
				For $i = 0 To UBound($array, 2) - 1
					Local $temp = $array[$start2][$i]
					$array[$start2][$i] = $array[$end2][$i]
					$array[$end2][$i] = $temp
				Next
				$start2 += 1
				$end2 -= 1
			EndIf
		Until $start2 > $end2
		quicksort($array, $start, $end2)
		quicksort($array, $start2, $end)
	EndIf
EndFunc

; Lecture rapide des tableaux associatifs
Func quickget($array, $key)
	Local $start = 1, $end = $array[0][0], $resultat = ""
	Do
		Local $i = Floor(($start+$end)/2), $compare = StringCompare($key, $array[$i][0], 2)
		If $compare = 0 Then
			$resultat = $array[$i][1]
		ElseIf $compare < 0 Then
			$end = $i-1
		ElseIf $compare > 0 Then
			$start = $i+1
		EndIf
	Until $start>$end Or $compare = 0
	Return SetError(($compare=0 ? 0 : 1), $i, $resultat)
EndFunc

; Affichage d'un sousmenu
Func sousmenu($gui, $target, $context)
	Local $menu = GUICtrlGetHandle($context), $coords = DllStructCreate("int;int")
	If IsArray($target) Then
		DllStructSetData($coords, 1, $target[0])
		DllStructSetData($coords, 2, $target[1])
	ElseIf $target = 0 Then
		DllStructSetData($coords, 1, MouseGetPos(0))
		DllStructSetData($coords, 2, MouseGetPos(1))
	Else
		Local $position = ControlGetPos($gui, "", $target)
		DllStructSetData($coords, 1, $position[0]+10)
		DllStructSetData($coords, 2, $position[1]+10)
		DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $gui, "ptr", DllStructGetPtr($coords))
	EndIf
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $menu, "int", 0, "int", DllStructGetData($coords, 1), "int", DllStructGetData($coords, 2), "hwnd", $gui, "ptr", 0)
EndFunc

; Vrification d'un tat sur un contrle donn
Func _GUICtrlGetState($element, $state)
	Return BitAND(GUICtrlGetState($element), $state) = $state
EndFunc

; Vrification de l'tat sur un contrle donn de type CheckBox
Func _GUICtrlGetCheck($element, $state=1) ; $GUI_CHECKED = 1
	Return BitAND(GUICtrlRead($element), $state) = $state
EndFunc

; Affection d'tat  un contrle selon la ncessit
Func _GUICtrlSetState($element, $state)
	If Not _GUICtrlGetState($element, $state) Then GUICtrlSetState($element, $state)
EndFunc

; Affection de coche  un contrle donn de type CheckBox selon la ncessit
Func _GUICtrlSetCheck($element, $state)
	_GUICtrlSetState($element, ($state ? 1 : 4)) ; $GUI_CHECKED = 1 ; $GUI_UNCHECKED = 4
EndFunc

; Affectation d'une image  un contrle donn de type Button
Func _GUICtrlSetImage($element, $path, $index = -1)
	Local $previous = 0
	If $index = -1 Then
		Local $image = _WinAPI_LoadImage(0, $path, 1, 0, 0, BitOR($LR_LOADFROMFILE, $LR_CREATEDIBSECTION))
		If Not $image Then Return False
		$previous = _SendMessage(GUICtrlGetHandle($element), 0xF7, 1, $image) ; $BM_SETIMAGE = 0xF7
	Else
		Local $struct = DllStructCreate("handle Handle"), $extract = _WinAPI_ExtractIconEx($path, $index, 0, $struct, 1)
		If Not $extract Then Return False
		$previous = _SendMessage(GUICtrlGetHandle($element), 0xF7, 1, DllStructGetData($struct, "Handle")) ; $BM_SETIMAGE = 0xF7
	EndIf
	If $previous Then
		If Not _WinAPI_DeleteObject($previous) Then _WinAPI_DestroyIcon($previous)
	EndIf
	_WinAPI_UpdateWindow(GUICtrlGetHandle($element)) ; force a WM_PAINT
	Return True
EndFunc

; Fonction de listing de fichiers
Func listFiles($path, $filter)
	Local $resultat = "", $root = StringRegExpReplace($path, "[\\/]+$", "")
	If Not FileExists($root & "\") Or StringRegExp($filter, "[\\/:><\|]|(?s)^\s*$") Then Return SetError(1)
	Local $search = FileFindFirstFile($root & "\" & $filter)
	If @error Then Return SetError(2)
	Do
		Local $file = FileFindNextFile($search)
		If Not @error And @extended <> 1 Then $resultat &= ($resultat=""?"":"|") & $file
	Until @error
	FileClose($search)
	If $resultat = "" Then Return SetError(3)
	Return StringSplit($resultat, "|")
EndFunc

; Fonction de listing de dossiers
Func listFolders($path, $filter)
	Local $resultat = "", $root = StringRegExpReplace($path, "[\\/]+$", "")
	If Not FileExists($root & "\") Or StringRegExp($filter, "[\\/:><\|]|(?s)^\s*$") Then Return SetError(1)
	Local $search = FileFindFirstFile($root & "\" & $filter)
	If @error Then Return SetError(2)
	Do
		Local $folder = FileFindNextFile($search)
		If Not @error And @extended <> 0 Then $resultat &= ($resultat=""?"":"|") & $folder
	Until @error
	FileClose($search)
	If $resultat = "" Then Return SetError(3)
	Return StringSplit($resultat, "|")
EndFunc

; Comparaison de numros de versions
Func compareVersion($version1, $version2)
	Local $resultat = 0, $no_version = "0.0", $pattern = "^([0-9]+)\.([0-9]+)([a-z]?)$"
	If Not StringRegExp($version1, $pattern) Then $version1 = $no_version
	If Not StringRegExp($version2, $pattern) Then $version2 = $no_version
	If $resultat = 0 Then $resultat = Int(StringRegExpReplace($version1,$pattern,"$1")) - Int(StringRegExpReplace($version2,$pattern,"$1"))
	If $resultat = 0 Then $resultat = Int(StringRegExpReplace($version1,$pattern,"$2")) - Int(StringRegExpReplace($version2,$pattern,"$2"))
	If $resultat = 0 Then $resultat = Asc(StringRegExpReplace($version1,$pattern,"$3")) - Asc(StringRegExpReplace($version2,$pattern,"$3"))
	Return $resultat
EndFunc

Func NAIO_fields($value=0)
	Local $reset = ($value = Default), $declared = IsDeclared("NAIO_fields")
	If Not $declared Or $reset Then
		If Not $declared Then Global $NAIO_fields ; [name|type|version|fullversion|author|comment|url|project]
		If @Compiled Then
			Local $resources[10][2] = [[9] _
				, ["name",               "name"] _
				, ["type",               "type"] _
				, ["version",         "version"] _
				, ["fullversion", "FileVersion"] _
				, ["author",   "LegalCopyright"] _
				, ["comment",        "Comments"] _
				, ["url",                 "url"] _
				, ["language",       "Language"] _
				, ["project",         "PROJECT"] _
			]
			For $i = 1 To $resources[0][0]
				Local $field = FileGetVersion(@ScriptFullPath, $resources[$i][1])
				If Not @error Then
					$resources[$i][1] = StringStripWS($field, 1+2)
				Else
					$resources[$i][1] = "["&$resources[$i][0]&"]"
				EndIf
			Next
			quicksort($resources)
			$NAIO_fields = $resources
		Else
			Local $entete = FileRead(@ScriptFullPath, 1000)
			Local $resources[10][2] = [[9] _
				, ["name",        "Field=name\|"] _
				, ["type",        "Field=type\|"] _
				, ["version",  "Field=version\|"] _
				, ["fullversion", "Fileversion="] _
				, ["author",   "LegalCopyright="] _
				, ["comment",         "Comment="] _
				, ["url",          "Field=url\|"] _
				, ["language",       "Language="] _
				, ["project",  "Field=PROJECT\|"] _
			]
			For $i = 1 To $resources[0][0]
				Local $field = StringRegExp($entete, "\n#AutoIt3Wrapper_Res_"&$resources[$i][1]&"([^\n]*)\n", 1)
				If Not @error Then
					$resources[$i][1] = StringStripWS($field[0], 1+2)
				Else
					$resources[$i][1] = "["&$resources[$i][0]&"]"
				EndIf
			Next
			quicksort($resources)
			$NAIO_fields = $resources
		EndIf
	EndIf
	Local $resultat = $NAIO_fields
	If @NumParams > 0 And Not $reset Then $NAIO_fields = $value
	Return $resultat
EndFunc
